/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.examples;

import com.trolltech.qt.core.*;
import com.trolltech.qt.gui.*;

@QtJambiExample(name = "Digital Clock")
public class DigitalClock extends QLCDNumber
{
    public DigitalClock()
    {
        setSegmentStyle(SegmentStyle.Filled);

        QTimer timer = new QTimer(this);
        timer.timeout.connect(this, "showTime()");
        timer.start(1000);

        showTime();

        setWindowTitle(tr("Digital Clock"));
        resize(150, 60);
    }

    public void showTime()
    {
        QTime time = QTime.currentTime();
        StringBuffer text = new StringBuffer(time.toString("hh:mm"));
        if ((time.second() % 2) == 0)
            text.setCharAt(2, ' ');
        display(text.toString());
    }

    public static void main(String args[])
    {
        QApplication.initialize(args);

        new DigitalClock().show();

        QApplication.exec();
    }
}
