/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.qt;

/**
 * @exclude
 */
class QThreadManager {

    private static class NativeResourcesReleaseThread extends Thread {
        private int m_sleepTime = 100;

        public NativeResourcesReleaseThread() {
            setDaemon(true);
        }

        @Override
        public void run() {
            while (true) {
                try { sleep(m_sleepTime); } catch (Exception e) { };
                boolean release = releaseNativeResources();
                m_sleepTime = release ? 100 : Math.min(m_sleepTime * 2, 60 * 1000);
            }
        }
    }

    public static void initialize() {
        new NativeResourcesReleaseThread().start();
    }

    public synchronized static native boolean releaseNativeResources();
}
