/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.qt;

/**
 * The QtEnumerator interface servers as a base for all Qt Jambi enums
 * and flags. Its sole purpose is to unify the access to the integer
 * value of enumerators and flags using the value() method.
 *
 * If you manually implement this class, your implementation must contain a method
 * with the following signature:
 *
 *      public static T resolve(int value);
 *
 * where T is your subclass. This should return the enum value corresponding to the
 * specified int value.
 */
public interface QtEnumerator {
    /**
     * This function should return an integer value for the enum
     * values of the enumeration that implements this interface.
     */
    public int value();
}
