/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.qt;

import java.lang.annotation.*;

/**
 * QtPropertyWriter annotates a method as being a setter for a property.
 * The annotation specifies the name of the property and whether the
 * property is enabled for writing.
 *
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface QtPropertyWriter {
    /** Returns true if the property is enabled; otherwise, returns false. */
    boolean enabled() default true;
    /** Returnd the name of the property. */
    String name() default "";
}
