/****************************************************************************
 **
 ** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
 **
 ** This file is part of Qt Jambi.
 **
 ** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ****************************************************************************/

package com.trolltech.qt.designer;

import com.trolltech.qt.gui.*;
import com.trolltech.qt.*;
import com.trolltech.qt.core.*;

class Line extends QFrame {

    public Line() {
        this(null);
    }

    public Line(QWidget parent) {
        super(parent);
        setFrameShadow(QFrame.Shadow.Sunken);
    }

    @QtPropertyWriter(name="orientation")
    public void setOrientation(Qt.Orientation orient) {
        if (orient == Qt.Orientation.Horizontal)
            setFrameShape(QFrame.Shape.HLine);
        else
            setFrameShape(QFrame.Shape.VLine);
    }
}
