/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "customtypes.h"

#include "metajava.h"

#include <QtCore/QDebug>
#include <QtCore/QTextStream>


void QModelIndexTypeEntry::generateCppJavaToQt(QTextStream &s,
                                               const AbstractMetaType *,
                                               const QString &env_name,
                                               const QString &qt_name,
                                               const QString &java_name) const
{
    s << "QModelIndex " << qt_name << " = qtjambi_to_QModelIndex(" << env_name << ", "
      << java_name << ")";
}


void QModelIndexTypeEntry::generateCppQtToJava(QTextStream &s,
                                               const AbstractMetaType *,
                                               const QString &env_name,
                                               const QString &qt_name,
                                               const QString &java_name) const
{
    s << "jobject " << java_name << " = qtjambi_from_QModelIndex(" << env_name << ", "
      << qt_name << ")";
}
