/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef GENERATOR_SET_H
#define GENERATOR_SET_H

#include <QObject>
#include <QString>
#include <QStringList>
#include <QMap>

class GeneratorSet : public QObject
{
    Q_OBJECT

 public:
    GeneratorSet();

    virtual QString usage() = 0;
    virtual bool readParameters(const QMap<QString, QString> args) = 0;
    virtual void buildModel(const QString pp_file) = 0;
    virtual void dumpObjectTree() = 0;
    virtual QString generate() = 0;

    static GeneratorSet *getInstance();
    QString outDir;
    bool printStdout;
};

#endif // GENERATOR_SET_H
