/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef GENERATOR_SET_JAVA_H
#define GENERATOR_SET_JAVA_H

#include "generatorset.h"
#include "metajavabuilder.h"

class GeneratorSetJava : public GeneratorSet
{
    Q_OBJECT

public:
    GeneratorSetJava();

    QString usage();
    bool readParameters(const QMap<QString, QString> args);

    void buildModel(const QString pp_file);
    void dumpObjectTree();

    QString generate();

private:

    bool no_java;
    bool no_cpp_h;
    bool no_cpp_impl;
    bool no_metainfo;
    bool build_class_list;
    bool build_qdoc_japi;
    bool docs_enabled;
    bool do_ui_convert;
    bool native_jump_table;

    QString doc_dir;
    QString ui_file_name;
    QString custom_widgets;

    MetaJavaBuilder builder;

};

#endif // GENERATOR_SET_JAVA_H
