/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef GAMEACTION_H
#define GAMEACTION_H

#include "gamenamespace.h"

#include <QtCore/QVector>

class AbstractGameObject ;
class GameScene ;

class GameAction
{
public:
    inline GameAction(Game::ActionType type) : m_type(type)
    {
    }
    virtual ~GameAction(){}

    virtual bool perform(GameScene *scene);
    virtual GameAction *clone() const = 0;

    inline void addObject(AbstractGameObject *o) { objects.append(o); }
    inline void addSubject(AbstractGameObject *o) { subjects.append(o); }

    inline Game::ActionType type() const { return m_type; }

protected:
    QVector<AbstractGameObject *> subjects;
    QVector<AbstractGameObject *> objects;

private:
    Game::ActionType m_type;

};

#endif
