/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "gameanimation.h"

GameAnimation::GameAnimation(Game::AnimationType type)
    : m_type(type), m_speed(0), m_looping(false), m_current_frame(0)
{
}

GameAnimation::~GameAnimation()
{
}

bool GameAnimation::update()
{
    int elapsed = m_time.elapsed();
    if (m_speed > 0 && !m_frames.isEmpty()) {
        int frames = int(elapsed / double(m_speed));

        if (!m_looping && frames + m_current_frame >= m_frames.size())
            m_current_frame = m_frames.size() - 1;
        else
            m_current_frame = (m_current_frame + frames) % m_frames.size();

        if (frames > 0) {
            m_time.restart();
            return true;
        }
    }
    return false;
}
