/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef GAMEGRAMMAR_H
#define GAMEGRAMMAR_H

#include <QtCore/QString>
#include <QtCore/QHash>
#include <QtCore/QStringList>

class GameScene ;
class GameAction ;
class AbstractGameObject ;

class GameGrammar
{
public:
    GameGrammar(GameScene *scene);
    virtual ~GameGrammar();

    void registerGameObject(AbstractGameObject *gameObject);
    void addNameToGameObject(AbstractGameObject *gameObject, const QString &other_name);
    void addVerb(const QString &verb, GameAction *action)
    {
        m_actions[verb] = action;
    }

    virtual void parse(const QString &command);

protected:
    virtual GameAction *command();
    virtual GameAction *verb();
    virtual AbstractGameObject *object();

    virtual bool filler();
    virtual bool and_token();
    virtual QString currentToken(int token_count = 1) const;
    virtual void nextToken();

    QHash<QString, AbstractGameObject *> m_objects;
    QHash<QString, GameAction *> m_actions;
    GameScene *m_scene;
    QStringList m_current_command;
};

#endif
