/****************************************************************************
**
** Copyright (C) 1992-2008 Trolltech ASA. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** Licensees holding valid Qt Evaluation licenses may use this file in
** accordance with the Qt Evaluation License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QTJAMBI_DEBUG_TOOLS_H
#define QTJAMBI_DEBUG_TOOLS_H

#if defined(QTJAMBI_DEBUG_TOOLS)

#include "qtjambi_global.h"

#define QTJAMBI_COUNTER_DECLARATIONS(NAME) \
    void QTJAMBI_EXPORT qtjambi_increase_##NAME(const QString &className)

    QTJAMBI_COUNTER_DECLARATIONS(finalizedCount);
    QTJAMBI_COUNTER_DECLARATIONS(userDataDestroyedCount);
    QTJAMBI_COUNTER_DECLARATIONS(destructorFunctionCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(shellDestructorCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(objectInvalidatedCount);
    QTJAMBI_COUNTER_DECLARATIONS(disposeCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(linkDestroyedCount);
    QTJAMBI_COUNTER_DECLARATIONS(linkConstructedCount);

#else
#  error Don't include this file without QTJAMBI_DEBUG_TOOLS defined
#endif

#endif
